@use '../../../global/styles/utilities' as *;
@use '../../../global/styles/styles-variables' as *;
@use './styles/form-select-filter.variables' as *;
@use './styles/form-select-filter.variations' as variations;


:host {
	@include digi-form-select-filter--variables;
	$base: '.digi-form-select-filter';

	box-sizing: content-box;

	.digi-form-select-filter {
		display: flex;
		flex-direction: column;
		gap: 0.4em;
		position: relative;

		--INDICATOR--BACKGROUND: var(--digi--form-select-filter--toggle-button-indicator--color--default);
		--SCROLL--MAX-HEIGHT: var(--digi--form-select-filter--scroll--max-height);

		&--neutral {
			@include variations.neutral;
		}

		&--success {
			@include variations.success;
		}

		&--warning {
			@include variations.warning;
		}

		&--error {
			@include variations.error;
		}

		&--open {
			#{$base}__toggle-icon {
				transform: rotate(-180deg);
			}
		}

		&__toggle-button {

			background: var(--BACKGROUND);
			border: var(--BORDER-WIDTH) solid var(--BORDER-COLOR);
			border-radius: var(--digi--border-radius--input);
			color: var(--digi--color--text--primary);
			cursor: pointer;
			display: flex;
			justify-content: space-between;
			align-items: center;
			font-weight: 400;
			font-size: var(--digi--typography--body--font-size--desktop);
			width: 100%;
			padding: 0 var(--digi--gutter--medium);
			min-height: var(--digi--input-height--medium);
			font-family: var(--digi--global--typography--font-family--default);

			&:focus-visible,
			&:focus {
				outline: var(--digi--focus-outline);
				box-shadow: var(--digi--focus-shadow);
			}
		}
		&__toggle-icon {
			::slotted([slot^='icon']) {
				--digi--icon--width: var(--digi--form-select-filter--toggle-icon--width);
				--digi--icon--height: var(--digi--form-select-filter--toggle-icon--height);
			}
			transition: var(--digi--form-select-filter--toggle-icon--transition);
		}

		&__legend {
			font-weight: var(--digi--form-select-filter--legend--font-weight);
			font-family: var(--digi--form-select-filter--legend--font-family);
			font-size: var(--digi--form-select-filter--legend--font-size);
			border: 0;
			padding: 0;
			margin: 0;
			@include digi--a11y--sr-only;
		}

		&__scroll {
			max-height: var(--SCROLL--MAX-HEIGHT);
			overflow-y: auto;
		}

		&__header {
			background-color: var(--digi--form-select-filter--dropdown--header--background);

			padding: 12px 12px 22px;

			input {
				border-radius: var(--digi--form-select-filter--search-input--border-radius);
				border-width: var(--digi--form-select-filter--search-input--border-width);
				border-style: var(--digi--form-select-filter--search-input--border-style);
				border-color: var(--digi--form-select-filter--search-input--border-color);
				height: var(--digi--form-select-filter--search-input--height);
				width: var(--digi--form-select-filter--search-input--width);
			}

			legend {
				width: 100%;
				border-bottom: var(--digi--form-select-filter--legend__border-bottom);
			}
		}
		&__footer {
			display: flex;
			align-items: center;
			justify-content: center;
			background: var(--digi--form-select-filter--footer--background);
			padding: var(--digi--form-select-filter--scroll--padding);
		}

		&__reset-button {
			display: inline-block;
			margin-right: var(--digi--form-select-filter--reset-button--margin-right);
		}

		&__dropdown {
			min-width: var(--digi--form-select-filter--dropdown--min-width);
			width: 100%;
			position: absolute;
			z-index: var(--digi--form-select-filter--dropdown--z-index);
			background: var(--digi--form-select-filter--dropdown--background);
			border-radius: var(--digi--form-select-filter--dropdown--border-radius);
			box-shadow: var(--digi--form-select-filter--dropdown--box-shadow);
			overflow: hidden;
			margin-top: var(--digi--form-select-filter--dropdown--margin-top);

			fieldset {
				border: none;

				padding: 0;
				margin: 0;
			}

			&--right {
				@media (min-width: $digi--breakpoint--medium) {
					right: 0;
				}
			}

      &--hidden {
        display: none;
      }
		}

		&__label {
			display: block;
		}

		&__toggle-button-wrapper{
			&--activated{
			display: flex;
    	align-items: center;
			}
		}

		&__toggle-button-indicator {
			display: none;
			--digi--icon--color: var(--digi--form-select-filter--toggle-button-indicator--color);
			&--active {
				display: flex;
				margin-right: var(--digi--form-select-filter--toggle-button-indicator--margin-right);
				width: var(--digi--form-select-filter--toggle-button-indicator--width);
				height: var(--digi--form-select-filter--toggle-button-indicator--height);
			}
		}

		&__search-status {
			font-family: var(--digi--global--typography--font-family--default);
			font-size: var(--digi--typography--label--font-size--desktop);
			color: var(--digi--color--text--primary);
		}

		&__list {
			margin: var(--digi--form-select-filter--list--margin);
			padding: 0;
			max-width: 100%;
		}

		&__item {
			background-color: var(--digi--form-select-filter--dropdown--item--background-color--default);
			border-width: 0;
			box-sizing: content-box;
			border-bottom-width: var(--digi--form-select-filter--dropdown--item--border-width);
			border-style: var(--digi--form-select-filter--dropdown--item--border-type);
			border-color: var(--digi--form-select-filter--dropdown--item--border-color);
			cursor: var(--digi--form-select-filter--dropdown--item--cursor);
			color: var(--digi--form-select-filter--dropdown--item--color);
			display: block;
			font-size: var(--digi--form-select-filter--dropdown--item--font-size);
			font-family: var(--digi--form-select-filter--dropdown--item--font-family);
			font-weight: var(--digi--form-select-filter--dropdown--item--font-weight--default);
			padding: var(--digi--form-select-filter--dropdown--item--padding-y) var(--digi--form-select-filter--dropdown--item--padding-x);
			position: relative;
			height: var(--digi--form-select-filter--dropdown--item--height);

			margin-bottom: var(--digi--form-select-filter--dropdown--item--margin-bottom);

			letter-spacing: var(--digi--form-select-filter--dropdown--item--letter-spacing);
			line-height: var(--digi--form-select-filter--dropdown--item--line-height);

			&:focus-visible {
				background-color: var(--digi--form-select-filter--dropdown--item--background-color--focus);
			}
			&:hover {
				background-color: var(--digi--form-select-filter--dropdown--item--background-color--hover);
				font-weight: var(--digi--form-select-filter--dropdown--item--font-weight--hover);
			}

			&:active {
				background-color: var(--digi--form-select-filter--dropdown--item--background-color--active);
			}

			&[aria-checked='true'] {
				font-weight: var(--digi--form-select-filter--dropdown--item--font-weight--selected);
				background-color: var(--digi--form-select-filter--dropdown--item--background-color--selected);
			}

			&[role='radio'] {
				.digi-form-select-filter__item__icon {
					position: absolute;
					width: 13px;
					height: 25px;
					left: 7px;
				}
				&[dir='rtl'] {
					&::before {
						right: 3px;
					}
					.digi-form-select-filter__item__icon {
						left: auto;
						right: 7px;
					}
				}
			}

			&[role='checkbox'] {
				padding: var(--digi--form-select-filter--dropdown--item--multiple--padding-y) var(--digi--form-select-filter--dropdown--item--multiple--padding-x);

				&::before {
					content: '';
					position: absolute;
					background-color: var(--digi--form-select-filter--dropdown--item--checkbox--background-color);
					border-color: var(--digi--form-select-filter--dropdown--item--checkbox--border-color);
					border-width: var(--digi--form-select-filter--dropdown--item--checkbox--border-width);
					border-style: var(--digi--form-select-filter--dropdown--item--checkbox--border-style);
					height: var(--digi--form-select-filter--dropdown--item--checkbox--width);
					width: var(--digi--form-select-filter--dropdown--item--checkbox--height);
					border-radius: var(--digi--form-select-filter--dropdown--item--checkbox--border-radius);
					left: 12px;
					transform: translateY(1px);
				}
				.digi-form-select-filter__item__icon {
					position: absolute;
					width: 13px;
					left: 16px;
				}
				&[dir='rtl'] {
					&::before {
						right: 12px;
					}
					.digi-form-select-filter__item__icon {
						left: auto;
						right: 16px;
					}
				}
			}
		}

		&__toggle-button-text {
			margin-right: var(--digi--form-select-filter--toggle-button--text--margin-right);
		}
	}
}
